//------------------------------------------------------------------+
//#property link      "www.forex-tsd.com"   Mladen 15 March 2012    |
//#property copyright "www.forex-tsd.com"                           |
//------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  Lime
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_color4  Red
#property indicator_color5  DodgerBlue
#property indicator_color6  Yellow//Red 
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  2
#property indicator_width6  2
#property indicator_level1  0
#property indicator_level2   80
#property indicator_level3  -80  
#property indicator_levelcolor Gold

//
//
//
//
//

extern string TimeFrame                 = "Current time frame";
extern double Period1                   =   8;//32
extern double Period2                   =   5;
extern double Period3                   =   5;
extern int    Price                     = PRICE_CLOSE;
extern bool   divergenceVisible         = true;//********* NB
extern bool   divergenceOnValuesVisible = true;
extern bool   divergenceOnChartVisible  = true;
extern color  divergenceBullishColor    = LimeGreen;
extern color  divergenceBearishColor    = OrangeRed;
extern string divergenceUniqueID        = "Blau tsi divergence1";
extern bool   Interpolate               = true;
extern bool   ShowArrows                = true ;//****
extern string ArrowsIdentifier          = "BlauTSI arrows";
extern double ArrowsUpGap               = 0.15;//0.75
extern double ArrowsDownGap             = 0.55;//*********
extern color  ArrowUpColor              = Yellow;//LimeGreen;
extern int    ArrowUpWidth              = 2;
extern color  ArrowDownColor            = Yellow;//PaleVioletRed; 
extern int    ArrowDownWidth            = 2; 
extern bool   ShowHistogram             = true;//********* NB

double tsi[];
double tsihuu[];
double tsihud[];
double tsihdd[];
double tsihdu[];
double signal[];
double slope[];
double trend[];

//
//
//
//
//

string shortName;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;
bool   calculateMa;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   int type = DRAW_NONE; if (ShowHistogram) type = DRAW_HISTOGRAM;
   IndicatorBuffers(8);
   SetIndexBuffer(0,tsihuu); SetIndexStyle(0, type);
   SetIndexBuffer(1,tsihud); SetIndexStyle(1, type);
   SetIndexBuffer(2,tsihdd); SetIndexStyle(2, type);
   SetIndexBuffer(3,tsihdu); SetIndexStyle(3, type);
   SetIndexBuffer(4,tsi);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);
   
      //
      //
      //
      //
      //
      
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue");
      if (calculateValue)
      {
         int s = StringFind(divergenceUniqueID,":",0);
               shortName = divergenceUniqueID;
               divergenceUniqueID = StringSubstr(divergenceUniqueID,0,s);
               return(0);
      }            
      timeFrame = stringToTimeFrame(TimeFrame);
      
      //
      //
      //
      //
      //
      
      shortName = divergenceUniqueID+": "+timeFrameToString(timeFrame)+" true strength index ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")";
      IndicatorShortName(shortName);   
   return(0);
}
int deinit()
{
   int lookForLength = StringLen(divergenceUniqueID);
      for (int i=ObjectsTotal()-1; i>=0; i--) 
      {
         string name = ObjectName(i);  if (StringSubstr(name,0,lookForLength) == divergenceUniqueID) ObjectDelete(name);
      }
   lookForLength = StringLen(ArrowsIdentifier);
      for (i=ObjectsTotal(); i>= 0; i--)
      {
         name = ObjectName(i); if (StringSubstr(name,0,lookForLength) == ArrowsIdentifier) ObjectDelete(name);  
      }
      
   return(0); 
}

//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tsihuu[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         double priceDiff = iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,1,0,MODE_SMA,Price,i+1);
         double avg = iEma(iEma(        priceDiff ,Period1,i,0),Period2,i,1);
         double ava = iEma(iEma(MathAbs(priceDiff),Period1,i,2),Period2,i,3);
            if (ava != 0)
                  tsi[i] = 100.0*avg/ava;
            else  tsi[i] = 0;                  
            tsihuu[i] = EMPTY_VALUE;
            tsihud[i] = EMPTY_VALUE;
            tsihdd[i] = EMPTY_VALUE;
            tsihdu[i] = EMPTY_VALUE;
            signal[i] = iEma(tsi[i],Period3,i,4);

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
               if (tsi[i] > tsi[i+1])  slope[i] =  1;
               if (tsi[i] < tsi[i+1])  slope[i] = -1;
               if (tsi[i] > signal[i]) trend[i] =  1;
               if (tsi[i] < signal[i]) trend[i] = -1;
               if (tsi[i]>0)
               if (slope[i]==1)
                     tsihuu[i] = tsi[i];
               else  tsihud[i] = tsi[i];
               if (tsi[i]<0)
               if (slope[i]==1)
                     tsihdu[i] = tsi[i];
               else  tsihdd[i] = tsi[i];
            if (divergenceVisible)
            {
              CatchBullishDivergence(tsi,i);
              CatchBearishDivergence(tsi,i);
            } 
            manageArrow(i);
      }
      return(0);
   }   
   
   //
   //
   //
   //
   //
   

   //
   //
   //
   //
   //



   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         tsi[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,ShowArrows,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,4,y);
         signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,ShowArrows,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,5,y);
         slope[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Price,divergenceVisible,divergenceOnValuesVisible,divergenceOnChartVisible,divergenceBullishColor,divergenceBearishColor,shortName,Interpolate,ShowArrows,ArrowsIdentifier,ArrowsUpGap,ArrowsDownGap,ArrowUpColor,ArrowUpWidth,ArrowDownColor,ArrowDownWidth,6,y);
         tsihuu[i] = EMPTY_VALUE;
         tsihud[i] = EMPTY_VALUE;
         tsihdd[i] = EMPTY_VALUE;
         tsihdu[i] = EMPTY_VALUE;
            if (tsi[i]>0)
               if (slope[i]==1)
                     tsihuu[i] = tsi[i];
               else  tsihud[i] = tsi[i];
            if (tsi[i]<0)
               if (slope[i]==1)
                     tsihdu[i] = tsi[i];
               else  tsihdd[i] = tsi[i];

         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  tsi[i+k]    = tsi[i]    + (tsi[i+n]    - tsi[i]   )*k/n;
                  signal[i+k] = signal[i] + (signal[i+n] - signal[i])*k/n;
               }                  
   }
   for (i=limit; i>=0; i--)
   {
      if (tsihuu[i] != EMPTY_VALUE) tsihuu[i] = tsi[i];
      if (tsihud[i] != EMPTY_VALUE) tsihud[i] = tsi[i];
      if (tsihdu[i] != EMPTY_VALUE) tsihdu[i] = tsi[i];
      if (tsihdd[i] != EMPTY_VALUE) tsihdd[i] = tsi[i];
   }
   
   //
   //
   //
   //
   //

   return(0);
   
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workEma[][5];
double iEma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workEma,0)!= Bars) ArrayResize(workEma,Bars); r = Bars-r-1;

   //
   //
   //
   //
   //
      
   double alpha = 2.0 / (1.0+period);
          workEma[r][instanceNo] = workEma[r-1][instanceNo]+alpha*(price-workEma[r-1][instanceNo]);
   return(workEma[r][instanceNo]);
}



//-------------------------------------------------------------------------------------------------
//
//-------------------------------------------------------------------------------------------------
//
//
//
//
//

void CatchBullishDivergence(double& values[], int i)
{
   i++;
            ObjectDelete(divergenceUniqueID+"l"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"l"+"os" + DoubleToStr(Time[i],0));            
   if (!IsIndicatorLow(values,i)) return;  

   //
   //
   //
   //
   //

   int currentLow = i;
   int lastLow    = GetIndicatorLastLow(values,i+1);
      if (values[currentLow] > values[lastLow] && Low[currentLow] < Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow],divergenceBullishColor,STYLE_SOLID);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow],divergenceBullishColor,STYLE_SOLID);
      }
      if (values[currentLow] < values[lastLow] && Low[currentLow] > Low[lastLow])
      {
         if(divergenceOnChartVisible)  DrawPriceTrendLine("l",Time[currentLow],Time[lastLow],Low[currentLow],Low[lastLow], divergenceBullishColor, STYLE_DOT);
         if(divergenceOnValuesVisible) DrawIndicatorTrendLine("l",Time[currentLow],Time[lastLow],values[currentLow],values[lastLow], divergenceBullishColor, STYLE_DOT);
      }
}

//
//
//
//
//

void CatchBearishDivergence(double& values[], int i)
{
   i++; 
            ObjectDelete(divergenceUniqueID+"h"+DoubleToStr(Time[i],0));
            ObjectDelete(divergenceUniqueID+"h"+"os" + DoubleToStr(Time[i],0));            
   if (IsIndicatorPeak(values,i) == false) return;

   //
   //
   //
   //
   //
      
   int currentPeak = i;
   int lastPeak = GetIndicatorLastPeak(values,i+1);
      if (values[currentPeak] < values[lastPeak] && High[currentPeak]>High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak],divergenceBearishColor,STYLE_SOLID);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak],divergenceBearishColor,STYLE_SOLID);
      }
      if(values[currentPeak] > values[lastPeak] && High[currentPeak] < High[lastPeak])
      {
         if (divergenceOnChartVisible)  DrawPriceTrendLine("h",Time[currentPeak],Time[lastPeak],High[currentPeak],High[lastPeak], divergenceBearishColor, STYLE_DOT);
         if (divergenceOnValuesVisible) DrawIndicatorTrendLine("h",Time[currentPeak],Time[lastPeak],values[currentPeak],values[lastPeak], divergenceBearishColor, STYLE_DOT);
      }
}

//
//
//
//
//

bool IsIndicatorPeak(double& values[], int i) { return(values[i] >= values[i+1] && values[i] > values[i+2] && values[i] > values[i-1]); }
bool IsIndicatorLow( double& values[], int i) { return(values[i] <= values[i+1] && values[i] < values[i+2] && values[i] < values[i-1]); }

int GetIndicatorLastPeak(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] >= values[i+1] && values[i] > values[i+2] && values[i] >= values[i-1] && values[i] > values[i-2]) return(i);
   return(-1);
}
int GetIndicatorLastLow(double& values[], int shift)
{
   for(int i = shift+5; i<Bars; i++)
         if (values[i] <= values[i+1] && values[i] < values[i+2] && values[i] <= values[i-1] && values[i] < values[i-2]) return(i);
   return(-1);
}

//+------------------------------------------------------------------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------------------------------------------------------------------
//
//
//
//
//

void DrawPriceTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   string   label = divergenceUniqueID+first+"os"+DoubleToStr(t1,0);
    
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, 0, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}
void DrawIndicatorTrendLine(string first,datetime t1, datetime t2, double p1, double p2, color lineColor, double style)
{
   int indicatorWindow = WindowFind(shortName);
   if (indicatorWindow < 0) return;
   
   string label = divergenceUniqueID+first+DoubleToStr(t1,0);
   ObjectDelete(label);
      ObjectCreate(label, OBJ_TREND, indicatorWindow, t1+Period()*60-1, p1, t2, p2, 0, 0);
         ObjectSet(label, OBJPROP_RAY, false);
         ObjectSet(label, OBJPROP_COLOR, lineColor);
         ObjectSet(label, OBJPROP_STYLE, style);
}

//---------------------------------------------------------------------------------------------------------------------
//
//---------------------------------------------------------------------------------------------------------------------
//
//
//
//
//

void manageArrow(int i)
{
   if (ShowArrows)
   {
      ObjectDelete(ArrowsIdentifier+Time[i]);         
            
      //
      //
      //
      //
      //
           
      if (trend[i] != trend[i+1])
      {
         string name = ArrowsIdentifier+Time[i];
         if (trend[i] == 1)
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],Low[i]-ArrowsUpGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,233);//241
               ObjectSet(name,OBJPROP_COLOR,ArrowUpColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowUpWidth);
         }
         else
         {
            ObjectCreate(name,OBJ_ARROW,0, Time[i],High[i]+ArrowsDownGap*iATR(NULL,0,20,i));
               ObjectSet(name,OBJPROP_ARROWCODE,234);//242
               ObjectSet(name,OBJPROP_COLOR,ArrowDownColor);
               ObjectSet(name,OBJPROP_WIDTH,ArrowDownWidth);
         }
      }
   }
}

//--------------------------------------------------------------------------------------------
//
//--------------------------------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}
//=======================================================================+